/* Egoboo - Md2.h
 *
 * Interface for loading Quake2/Egoboo models.
 */

#ifndef egoboo_Md2_h
#define egoboo_Md2_h


typedef struct Md2Vertex
{
	float x, y, z;
	unsigned normal;	// index to id-normal array
}Md2Vertex;

typedef struct Md2TexCoord
{
	float s, t;
}Md2TexCoord;

typedef struct Md2Triangle
{
	short vertexIndices[3];
	short texCoordIndices[3];
}Md2Triangle;

typedef struct Md2Frame
{
	char name[16];
	float min[3], max[3];		// axis-aligned bounding box limits
	Md2Vertex *vertices;
}Md2Frame;

typedef struct Md2SkinName
{
	char name[64];
}Md2SkinName;

typedef struct Md2Model
{
	int numVertices;
	int numTexCoords;
	int numTriangles;
	int numSkins;
	int numFrames;

	Md2SkinName *skins;
	Md2TexCoord *texCoords;
	Md2Triangle *triangles;
	Md2Frame    *frames;
}Md2Model;

extern Md2Model *md2_loadFromFile(const char *fileName);
extern void      md2_freeModel(Md2Model *model);

#endif // include guard
